.386
.model flat,syscall
option casemap:none

include		\masm32\include\windows.inc
include		Dlgbox.imp
include		invoke.inc

DlgProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
msg		db 'Dialog box demo',0
title1		db 'About',0
Resource	db 'MYDIALOG',0

.data?
hBrush		dd ?

IDM_ABOUT	equ 11
IDM_EXIT	equ 12
IDC_ABOUT	equ 110
IDC_EXIT	equ 120
IDC_EDIT	equ 3000

.code

_start:

	_invoke	GetModuleHandle,NULL
	_invoke	DialogBoxParam,eax,ADDR Resource,NULL,ADDR DlgProc,NULL
	_invoke	ExitProcess,eax

DlgProc	PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
	.IF uMsg==WM_INITDIALOG

		_invoke	LoadIcon,NULL,IDI_APPLICATION	
		_invoke	SendMessage,hWnd,WM_SETICON,ICON_SMALL,eax
        
	.ELSEIF uMsg==WM_CTLCOLORDLG

		_invoke	CreateSolidBrush,Blue
		mov		hBrush,eax
		ret

	.ELSEIF uMsg==WM_CLOSE
		
		_invoke	DeleteObject,hBrush
		_invoke	EndDialog,hWnd,NULL

	.ELSEIF	uMsg==WM_COMMAND
		
			mov	eax,wParam

			.IF	lParam==0

				.IF	ax==IDM_ABOUT

					_invoke	MessageBox,NULL,ADDR msg,ADDR title1,MB_OK
                        
				.ELSEIF	ax==IDM_EXIT

					_invoke	SendMessage,hWnd,WM_CLOSE,0,0

				.ENDIF

			.ELSE

				mov	edx,wParam
				shr	edx,16

					.IF dx==BN_CLICKED
                                
						.IF ax==IDC_ABOUT

							_invoke SendMessage,hWnd,WM_COMMAND,IDM_ABOUT,0
                        	
						.ELSEIF ax==IDC_EXIT

							_invoke	SendMessage,hWnd,WM_CLOSE,0,0

						.ENDIF

					.ENDIF

			.ENDIF
	.ELSE

		mov	eax,FALSE
		ret     16

	.ENDIF
	mov	eax,TRUE
	ret     16

DlgProc	ENDP
END	_start
